CREATE OR REPLACE PACKAGE VKREP AS

    --
    RTF_SECTION_BEGIN_BREAKED       CONSTANT CHAR :=    '{';
    RTF_SECTION_END_BREAKED         CONSTANT CHAR :=    '}';

    --
    REQUEST_DATA_BY_NUM_SYMBOL      CONSTANT CHAR :=    '@';
    REQUEST_DATA_BY_NAME_SYMBOL     CONSTANT CHAR :=    '~';

    --
    WM_USER                         CONSTANT INTEGER :=       0;
    WM_REP_START_REPORT             CONSTANT INTEGER :=       WM_USER+100;
    WM_REP_END_REPORT               CONSTANT INTEGER :=       WM_USER+101;

    --Describe errors
    WM_REP_THREAD_ERROR             CONSTANT INTEGER :=       WM_USER+102;
    WM_REP_OPEN_ERROR               CONSTANT INTEGER :=       WM_USER+103;
    WM_REP_CREATE_ERROR             CONSTANT INTEGER :=       WM_USER+104;
    WM_REP_MEM_ERROR                CONSTANT INTEGER :=       WM_USER+105;
    MEM_ERROR_SO_MUCH_THREADS       CONSTANT INTEGER :=       0;
    MEM_ERROR_INPUT_BUFFER          CONSTANT INTEGER :=       1;
    MEM_ERROR_INPUT_BUFFER_LOCK     CONSTANT INTEGER :=       2;
    MEM_ERROR_OUTPUT_BUFFER         CONSTANT INTEGER :=       3;
    MEM_ERROR_OUTPUT_BUFFER_LOCK    CONSTANT INTEGER :=       4;
    WM_REP_READ_ERROR               CONSTANT INTEGER :=       WM_USER+106;
    READ_ERROR                      CONSTANT INTEGER :=       0;
    READ_ERROR_ZERO                 CONSTANT INTEGER :=       1;
    WM_REP_SECTION_ERROR            CONSTANT INTEGER :=       WM_USER+107;
    WM_REP_WRITE_ERROR              CONSTANT INTEGER :=       WM_USER+108;

    --End describe errors

    WM_REP_MOVE             CONSTANT INTEGER :=  WM_USER+111;
    MOVE_TOP                CONSTANT INTEGER :=  0;
    MOVE_NEXT               CONSTANT INTEGER :=  1;
    MOVE_PREVIOUS           CONSTANT INTEGER :=  2;
    MOVE_BOTTOM             CONSTANT INTEGER :=  3;

    WM_REP_SECTION_PREPARE  CONSTANT INTEGER := WM_USER + 112;

    NEW_SECTION_START       CONSTANT INTEGER :=   WM_USER+200;

    RTF_HEADER              CONSTANT INTEGER :=  1;
    HEADER                  CONSTANT INTEGER :=  2;
    GROUP_HEADER            CONSTANT INTEGER :=  3;
    SUBGROUP_HEADER         CONSTANT INTEGER :=  4;
    SUBSUBGROUP_HEADER      CONSTANT INTEGER :=  5;
    SUPERSUBGROUP_HEADER    CONSTANT INTEGER :=  6;
    BODY_                   CONSTANT INTEGER :=  7;
    SUPERSUBGROUP_FOOTER    CONSTANT INTEGER :=  8;
    SUBSUBGROUP_FOOTER      CONSTANT INTEGER :=  9;
    SUBGROUP_FOOTER         CONSTANT INTEGER :=  10;
    GROUP_FOOTER            CONSTANT INTEGER :=  11;
    FOOTER                  CONSTANT INTEGER :=  12;
    RTF_FOOTER              CONSTANT INTEGER :=  13;

    LAST_DYN_SECTION        CONSTANT INTEGER :=  RTF_FOOTER + 100;

    WM_REP_RTF_HEADER           CONSTANT INTEGER :=  NEW_SECTION_START + RTF_HEADER           - 1;
    WM_REP_HEADER               CONSTANT INTEGER :=  NEW_SECTION_START + HEADER               - 1;
    WM_REP_GROUP_HEADER         CONSTANT INTEGER :=  NEW_SECTION_START + GROUP_HEADER         - 1;
    WM_REP_SUBGROUP_HEADER      CONSTANT INTEGER :=  NEW_SECTION_START + SUBGROUP_HEADER      - 1;
    WM_REP_SUBSUBGROUP_HEADER   CONSTANT INTEGER :=  NEW_SECTION_START + SUBSUBGROUP_HEADER   - 1;
    WM_REP_SUPERSUBGROUP_HEADER CONSTANT INTEGER :=  NEW_SECTION_START + SUPERSUBGROUP_HEADER - 1;
    WM_REP_BODY                 CONSTANT INTEGER :=  NEW_SECTION_START + BODY_                - 1;
    WM_REP_SUPERSUBGROUP_FOOTER CONSTANT INTEGER :=  NEW_SECTION_START + SUPERSUBGROUP_FOOTER - 1;
    WM_REP_SUBSUBGROUP_FOOTER   CONSTANT INTEGER :=  NEW_SECTION_START + SUBSUBGROUP_FOOTER   - 1;
    WM_REP_SUBGROUP_FOOTER      CONSTANT INTEGER :=  NEW_SECTION_START + SUBGROUP_FOOTER      - 1;
    WM_REP_GROUP_FOOTER         CONSTANT INTEGER :=  NEW_SECTION_START + GROUP_FOOTER         - 1;
    WM_REP_FOOTER               CONSTANT INTEGER :=  NEW_SECTION_START + FOOTER               - 1;
    WM_REP_RTF_FOOTER           CONSTANT INTEGER :=  NEW_SECTION_START + RTF_FOOTER           - 1;

    SECTION_DATA_REQUEST_BY_NUM     CONSTANT INTEGER := 0;
    SECTION_DATA_REQUEST_BY_NAME    CONSTANT INTEGER := 1;
    SECTION_CHECK                   CONSTANT INTEGER := 2;
    SECTION_BEGIN                   CONSTANT INTEGER := 3;
    SECTION_END                     CONSTANT INTEGER := 4;
    SECTION_DATA_REQUEST_BY_VALUE   CONSTANT INTEGER := 5;
    SECTION_DATA_REQUEST_BY_CELL    CONSTANT INTEGER := 6;
    SECTION_COMPLIT                 CONSTANT INTEGER := 7;

    --

    --Exception codes
    START_EXCEPTION_CODE         CONSTANT INTEGER :=   50000;

    WRITE_EXCEPTION              CONSTANT INTEGER :=   START_EXCEPTION_CODE + 1;
    SECTION_EXCEPTION            CONSTANT INTEGER :=   START_EXCEPTION_CODE + 2;
--
--
    LenLob          INTEGER;
    CursorID        INTEGER;
    CallBackBlock   VARCHAR2(2000);
    InputBlank      CLOB;
    OutputReport    CLOB;

    RQ_DATA_BY_NUM  CHAR;
    RQ_DATA_BY_NAME CHAR;

--
--
    TYPE NUM_COLLECTION_TYPE IS RECORD (
        NUM     INTEGER,
        TEXT    VARCHAR2(4000)
    );
    TYPE CHAR_COLLECTION_TYPE IS RECORD (
        CHR     VARCHAR2(255),
        TEXT    VARCHAR2(4000)
    );
    TYPE NUM_COLLECTION IS TABLE OF NUM_COLLECTION_TYPE INDEX BY BINARY_INTEGER;
    TYPE CHAR_COLLECTION IS TABLE OF CHAR_COLLECTION_TYPE INDEX BY BINARY_INTEGER;

    TYPE T_SECTION IS RECORD (
        SECTION_NAME    VARCHAR2(255),
        TEXT            VARCHAR2(32767),
        B_INDEX_CHAR    INTEGER,
        E_INDEX_CHAR    INTEGER,
        B_INDEX_NOM     INTEGER,
        E_INDEX_NOM     INTEGER
    );
    TYPE Sections_Type IS TABLE OF T_SECTION INDEX BY BINARY_INTEGER;
--
--
    Sections                Sections_Type;
    NUM_COLLECTIONS         NUM_COLLECTION;
    CHAR_COLLECTIONS        CHAR_COLLECTION;
--
    LAST_NUM                INTEGER;
    LAST_CHAR               INTEGER;
    FPrepareDynSection      BOOLEAN;
    FLastDynSection         INTEGER;
    lWM_REP_SECTION_PREPARE BOOLEAN;
--
--
    ucCheck                 BOOLEAN;
    RequestStr              VARCHAR2(4000);
--
--
    --private
    PROCEDURE PrepareCallBack;
    PROCEDURE ExecuteCallBack(pMessage IN INTEGER, pW IN INTEGER, pL IN INTEGER);
    PROCEDURE CloseCallBack;
    --protected
    FUNCTION PrpRTFHeader RETURN BOOLEAN;
    FUNCTION PrpRTFFooter RETURN BOOLEAN;
    PROCEDURE ParseSectionInternal( SectionText IN VARCHAR2,
                                    B_I IN OUT INTEGER,
                                    E_I IN OUT INTEGER,
                                    B_I_C IN OUT INTEGER,
                                    E_I_C IN OUT INTEGER);
    PROCEDURE PrepareSectionInternal(SectionNum IN INTEGER, SectionName IN VARCHAR2);
    PROCEDURE OutSectionInternal(SectionNum IN INTEGER, ucDefOut IN BOOLEAN);
    --public
    FUNCTION PrepareSection(SectionName IN VARCHAR2) RETURN INTEGER;
    PROCEDURE OutSection(SectionName IN VARCHAR2);
    PROCEDURE OutSection(SectionNum IN INTEGER);
    PROCEDURE ReportExecute(pCallBackProcName IN VARCHAR2, pInputBlank IN CLOB, pOutputReport IN OUT CLOB);

END VKREP;
/
CREATE OR REPLACE PACKAGE BODY VKREP AS

    PROCEDURE PrepareCallBack IS
    BEGIN
        CursorID := DBMS_SQL.OPEN_CURSOR;
        DBMS_SQL.PARSE(CursorID, CallBackBlock, DBMS_SQL.native);
    END;

    PROCEDURE ExecuteCallBack(pMessage IN INTEGER, pW IN INTEGER, pL IN INTEGER) IS
        QQ      INTEGER;
    BEGIN
        DBMS_SQL.BIND_VARIABLE(CursorID, ':pMess', pMessage);
        DBMS_SQL.BIND_VARIABLE(CursorID, ':pW', pW);
        DBMS_SQL.BIND_VARIABLE(CursorID, ':pL', pL);
        QQ := DBMS_SQL.EXECUTE(CursorID);
    END;

    PROCEDURE CloseCallBack IS
    BEGIN
        DBMS_SQL.CLOSE_CURSOR(CursorID);
    END;

    FUNCTION PrpRTFHeader RETURN BOOLEAN IS
        StartPos    INTEGER;
    BEGIN
        StartPos := DBMS_LOB.INSTR(InputBlank, '#BEGIN QREPORT');
        IF StartPos IS NOT NULL THEN
            IF StartPos > 0 THEN
                Sections(RTF_HEADER).TEXT := DBMS_LOB.SUBSTR(InputBlank, StartPos - 1, 1);
                StartPos := INSTR(Sections(RTF_HEADER).TEXT, '{', -1);
                IF StartPos <> 0 THEN
                    Sections(RTF_HEADER).SECTION_NAME := 'RTF_HEADER';
                    Sections(RTF_HEADER).TEXT := SUBSTR(Sections(RTF_HEADER).TEXT, 1, StartPos - 1);
                    ParseSectionInternal(   Sections(RTF_HEADER).TEXT,
                                            Sections(RTF_HEADER).B_INDEX_NOM,
                                            Sections(RTF_HEADER).E_INDEX_NOM,
                                            Sections(RTF_HEADER).B_INDEX_CHAR,
                                            Sections(RTF_HEADER).E_INDEX_CHAR);
                    RETURN TRUE;
                ELSE
                    RETURN FALSE;
                END IF;
            ELSE
                RETURN FALSE;
            END IF;
        ELSE
            RETURN FALSE;
        END IF;
    END;

    FUNCTION PrpRTFFooter RETURN BOOLEAN IS
        StartPos    INTEGER;
    BEGIN
        StartPos := DBMS_LOB.INSTR(InputBlank, '#END QREPORT');
        IF StartPos IS NOT NULL THEN
            IF StartPos > 0 THEN
                Sections(RTF_FOOTER).TEXT := DBMS_LOB.SUBSTR(InputBlank, DBMS_LOB.GETLENGTH(InputBlank) - (StartPos + 11), StartPos + 12);
                StartPos := INSTR(Sections(RTF_FOOTER).TEXT, '}');
                IF StartPos <> 0 THEN
                    Sections(RTF_FOOTER).SECTION_NAME := 'RTF_FOOTER';
                    Sections(RTF_FOOTER).TEXT := SUBSTR(Sections(RTF_FOOTER).TEXT, StartPos + 1, LENGTH(Sections(RTF_FOOTER).TEXT) - StartPos);
                    ParseSectionInternal(   Sections(RTF_FOOTER).TEXT,
                                            Sections(RTF_FOOTER).B_INDEX_NOM,
                                            Sections(RTF_FOOTER).E_INDEX_NOM,
                                            Sections(RTF_FOOTER).B_INDEX_CHAR,
                                            Sections(RTF_FOOTER).E_INDEX_CHAR);
                    RETURN TRUE;
                ELSE
                    RETURN FALSE;
                END IF;
            ELSE
                RETURN FALSE;
            END IF;
        ELSE
            RETURN FALSE;
        END IF;
    END;

    FUNCTION PrepareSection(SectionName IN VARCHAR2) RETURN INTEGER IS
        Ret     INTEGER;
    BEGIN
        IF NOT lWM_REP_SECTION_PREPARE THEN
            RAISE_APPLICATION_ERROR(-20001, 'Ellagial call. You can call FUNCTION PrepareSection only in OnPrepareSection event.');
        END IF;
        Ret := FLastDynSection;
        FLastDynSection := FLastDynSection + 1;
        FPrepareDynSection := TRUE;
        PrepareSectionInternal(Ret, SectionName);
        FPrepareDynSection := FALSE;
        RETURN Ret;
    END;

    PROCEDURE PrepareSectionInternal(SectionNum IN INTEGER, SectionName IN VARCHAR2) IS
        StartPos1    INTEGER;
        StartPos2    INTEGER;
    BEGIN
        IF FPrepareDynSection THEN
            StartPos1 := DBMS_LOB.INSTR(InputBlank, '#BEGIN SECTION \lquote ' || SectionName || '\rquote');
            StartPos2 := DBMS_LOB.INSTR(InputBlank, '#END SECTION \lquote ' || SectionName || '\rquote');
        ELSE
            StartPos1 := DBMS_LOB.INSTR(InputBlank, '#BEGIN ' || SectionName);
            StartPos2 := DBMS_LOB.INSTR(InputBlank, '#END ' || SectionName);
        END IF;
        IF (StartPos1 IS NOT NULL) AND (StartPos2 IS NOT NULL) THEN
            IF ((StartPos1 > 0) AND (StartPos2 > 0)) THEN

                IF ((StartPos2 - StartPos1) < 32000) THEN

                    Sections(SectionNum).SECTION_NAME := SectionName;

                    Sections(SectionNum).TEXT := DBMS_LOB.SUBSTR(InputBlank, StartPos2 - StartPos1, StartPos1);

                    StartPos1 := INSTR(Sections(SectionNum).TEXT, '}');
                    Sections(SectionNum).TEXT := SUBSTR(Sections(SectionNum).TEXT, StartPos1 + 1, LENGTH(Sections(SectionNum).TEXT) - StartPos1);

                    StartPos1 := INSTR(Sections(SectionNum).TEXT, '{', -1);
                    Sections(SectionNum).TEXT := SUBSTR(Sections(SectionNum).TEXT, 1, StartPos1 - 1);

                    ParseSectionInternal(   Sections(SectionNum).TEXT,
                                            Sections(SectionNum).B_INDEX_NOM,
                                            Sections(SectionNum).E_INDEX_NOM,
                                            Sections(SectionNum).B_INDEX_CHAR,
                                            Sections(SectionNum).E_INDEX_CHAR);
                ELSE
                    RAISE_APPLICATION_ERROR(-20001, 'SECTION LENGTH MORE THEN 32767: ' || TO_CHAR(StartPos2 - StartPos1));
                END IF;

            END IF;
        END IF;
    END;

    PROCEDURE ParseSectionInternal(SectionText IN VARCHAR2, B_I IN OUT INTEGER, E_I IN OUT INTEGER,
                                                            B_I_C IN OUT INTEGER, E_I_C IN OUT INTEGER) IS
        A   INTEGER;
        B   INTEGER;
        C   INTEGER;
        S   VARCHAR2(4);
        S2  VARCHAR2(255);
        S1  INTEGER;
        TR  BOOLEAN;
    BEGIN

        B_I := LAST_NUM;
        B_I_C := LAST_CHAR;

        A := 1;
        LOOP
            B := INSTR(SectionText, RQ_DATA_BY_NUM, A);
            EXIT WHEN B = 0;
            A := B + 1;
            S := SUBSTR(SectionText, A, 4);
            TR := TRUE;
            BEGIN
                S1 := TO_NUMBER(S);
            EXCEPTION
                WHEN OTHERS THEN TR := FALSE;
            END;
            IF TR THEN
                NUM_COLLECTIONS(LAST_NUM).NUM := S1;
                NUM_COLLECTIONS(LAST_NUM).TEXT := '';
                LAST_NUM := LAST_NUM + 1;
            END IF;
        END LOOP;

        A := 1;
        LOOP
            B := INSTR(SectionText, RQ_DATA_BY_NAME, A);
            EXIT WHEN B = 0;
            A := B + 1;
            C := INSTR(SectionText, RQ_DATA_BY_NAME, A);
            EXIT WHEN C = 0;
            A := C + 1;
            IF (C - B - 1) > 0 THEN
                S2 := SUBSTR(SectionText, B + 1, C - B - 1);
                CHAR_COLLECTIONS(LAST_CHAR).CHR := S2;
                CHAR_COLLECTIONS(LAST_CHAR).TEXT := '';
                LAST_CHAR := LAST_CHAR + 1;
            END IF;
        END LOOP;

        E_I := LAST_NUM - 1;
        E_I_C := LAST_CHAR - 1;

    END;

    PROCEDURE OutSection(SectionName IN VARCHAR2) IS
        SectionNum  INTEGER;
    BEGIN
        IF      SectionName = 'HEADER'                  THEN OutSectionInternal(HEADER              , TRUE);
        ELSIF   SectionName = 'GROUP_HEADER'            THEN OutSectionInternal(GROUP_HEADER        , TRUE);
        ELSIF   SectionName = 'SUBGROUP_HEADER'         THEN OutSectionInternal(SUBGROUP_HEADER     , TRUE);
        ELSIF   SectionName = 'SUBSUBGROUP_HEADER'      THEN OutSectionInternal(SUBSUBGROUP_HEADER  , TRUE);
        ELSIF   SectionName = 'SUPERSUBGROUP_HEADER'    THEN OutSectionInternal(SUPERSUBGROUP_HEADER, TRUE);
        ELSIF   SectionName = 'BODY'                    THEN OutSectionInternal(BODY_               , TRUE);
        ELSIF   SectionName = 'SUPERSUBGROUP_FOOTER'    THEN OutSectionInternal(SUPERSUBGROUP_FOOTER, TRUE);
        ELSIF   SectionName = 'SUBSUBGROUP_FOOTER'      THEN OutSectionInternal(SUBSUBGROUP_FOOTER  , TRUE);
        ELSIF   SectionName = 'SUBGROUP_FOOTER'         THEN OutSectionInternal(SUBGROUP_FOOTER     , TRUE);
        ELSIF   SectionName = 'GROUP_FOOTER'            THEN OutSectionInternal(GROUP_FOOTER        , TRUE);
        ELSIF   SectionName = 'FOOTER'                  THEN OutSectionInternal(FOOTER              , TRUE);
        ELSE
            SectionNum := LAST_DYN_SECTION;
            LOOP
                SectionNum := Sections.Next(SectionNum);
                IF Sections(SectionNum).SECTION_NAME = SectionName THEN
                    OutSectionInternal(SectionNum, TRUE);
                    EXIT;
                END IF;
                EXIT WHEN SectionNum = Sections.Last;
            END LOOP;
        END IF;
    END;

    PROCEDURE OutSection(SectionNum IN INTEGER) IS
    BEGIN
        OutSectionInternal(SectionNum, TRUE);
    END;

    PROCEDURE OutSectionInternal(SectionNum IN INTEGER, ucDefOut IN BOOLEAN) IS
        LenStr          BINARY_INTEGER;
        SectionText     VARCHAR2(32767);
        MSTR            VARCHAR2(257);
    BEGIN
        ExecuteCallBack(NEW_SECTION_START + SectionNum - 1, 0, SECTION_BEGIN);
        IF Sections.Exists(SectionNum) THEN
            ucCheck := ucDefOut;
            ExecuteCallBack(NEW_SECTION_START + SectionNum - 1, 0, SECTION_CHECK);
            IF ((SectionNum = RTF_HEADER) OR (SectionNum = RTF_FOOTER)) THEN
                ucCheck := TRUE;
            END IF;
            IF ucCheck THEN
                SectionText := Sections(SectionNum).TEXT;
                FOR I IN Sections(SectionNum).B_INDEX_NOM .. Sections(SectionNum).E_INDEX_NOM LOOP
                    RequestStr := NULL;
                    ExecuteCallBack(NEW_SECTION_START + SectionNum - 1, NUM_COLLECTIONS(I).NUM, SECTION_DATA_REQUEST_BY_NUM);
                    MSTR := RQ_DATA_BY_NUM || LPAD(TO_CHAR(NUM_COLLECTIONS(I).NUM), 4, '0');
                    SectionText := REPLACE(SectionText, MSTR, RequestStr);
                END LOOP;
                FOR I IN Sections(SectionNum).B_INDEX_CHAR .. Sections(SectionNum).E_INDEX_CHAR LOOP
                    RequestStr := RQ_DATA_BY_NAME || CHAR_COLLECTIONS(I).CHR || RQ_DATA_BY_NAME;
                    MSTR := RQ_DATA_BY_NAME || CHAR_COLLECTIONS(I).CHR || RQ_DATA_BY_NAME;
                    ExecuteCallBack(NEW_SECTION_START + SectionNum - 1, 0, SECTION_DATA_REQUEST_BY_NAME);
                    SectionText := REPLACE(SectionText, MSTR, RequestStr);
                END LOOP;
                LenStr   := LENGTH(SectionText);
                DBMS_LOB.WRITE(OutputReport, LenStr, LenLob + 1, SectionText);
                LenLob := LenLob + LenStr;
                ExecuteCallBack(NEW_SECTION_START + SectionNum - 1, 0, SECTION_END);
            END IF;
        END IF;
        ExecuteCallBack(NEW_SECTION_START + SectionNum - 1, 0, SECTION_COMPLIT);
    END;

    PROCEDURE ReportExecute(pCallBackProcName IN VARCHAR2, pInputBlank IN CLOB, pOutputReport IN OUT CLOB) IS
        uiJ     INTEGER;
    BEGIN

        FPrepareDynSection := FALSE;
        lWM_REP_SECTION_PREPARE := FALSE;
        FLastDynSection := LAST_DYN_SECTION;

        LAST_NUM := 1;
        LAST_CHAR := 1;

        InputBlank      := pInputBlank;
        OutputReport    := pOutputReport;
        DBMS_LOB.TRIM(OutputReport, 0);
        LenLob := 0;
        CallBackBlock := 'BEGIN ' || LTRIM(RTRIM(pCallBackProcName)) || '(:pMess, :pW, :pL); END;';
        VKREP.PrepareCallBack;

        Sections.DELETE;
        NUM_COLLECTIONS.DELETE;
        CHAR_COLLECTIONS.DELETE;

        ExecuteCallBack(WM_REP_START_REPORT, 0, 0);
        IF PrpRTFHeader THEN
            IF PrpRTFFooter THEN

              PrepareSectionInternal(HEADER              , 'REPORT HEADER');
              PrepareSectionInternal(GROUP_HEADER        , 'GROUP HEADER');
              PrepareSectionInternal(SUBGROUP_HEADER     , 'SUBGROUP HEADER');
              PrepareSectionInternal(SUBSUBGROUP_HEADER  , 'SUBSUBGROUP HEADER');
              PrepareSectionInternal(SUPERSUBGROUP_HEADER, 'SUPERSUBGROUP HEADER');
              PrepareSectionInternal(BODY_               , 'BODY');
              PrepareSectionInternal(SUPERSUBGROUP_FOOTER, 'SUPERSUBGROUP FOOTER');
              PrepareSectionInternal(SUBSUBGROUP_FOOTER  , 'SUBSUBGROUP FOOTER');
              PrepareSectionInternal(SUBGROUP_FOOTER     , 'SUBGROUP FOOTER');
              PrepareSectionInternal(GROUP_FOOTER        , 'GROUP FOOTER');
              PrepareSectionInternal(FOOTER              , 'REPORT FOOTER');

              OutSectionInternal(RTF_HEADER, TRUE);

              lWM_REP_SECTION_PREPARE := TRUE;
              ExecuteCallBack(WM_REP_SECTION_PREPARE, 0, 0);
              lWM_REP_SECTION_PREPARE := FALSE;

              OutSectionInternal(HEADER, TRUE);
              uiJ := 1;
              ucCheck := FALSE;
              ExecuteCallBack(WM_REP_MOVE, uiJ, MOVE_TOP);
              WHILE NOT ucCheck LOOP
                OutSectionInternal(GROUP_HEADER        , FALSE);
                OutSectionInternal(SUBGROUP_HEADER     , FALSE);
                OutSectionInternal(SUBSUBGROUP_HEADER  , FALSE);
                OutSectionInternal(SUPERSUBGROUP_HEADER, FALSE);
                OutSectionInternal(BODY_               , TRUE);
                OutSectionInternal(SUPERSUBGROUP_FOOTER, FALSE);
                OutSectionInternal(SUBSUBGROUP_FOOTER  , FALSE);
                OutSectionInternal(SUBGROUP_FOOTER     , FALSE);
                OutSectionInternal(GROUP_FOOTER        , FALSE);
                ucCheck := FALSE;
                ExecuteCallBack(WM_REP_MOVE, uiJ, MOVE_NEXT);
                uiJ := uiJ + 1;
              END LOOP;
              OutSectionInternal(FOOTER, TRUE);
              OutSectionInternal(RTF_FOOTER, TRUE);

            ELSE
                ExecuteCallBack(WM_REP_SECTION_ERROR, 0, 0);
            END IF;
        ELSE
            ExecuteCallBack(WM_REP_SECTION_ERROR, 0, 0);
        END IF;
        pOutputReport := OutputReport;
        ExecuteCallBack(WM_REP_END_REPORT, 0, 0);
        VKREP.CloseCallBack;

        Sections.DELETE;
        NUM_COLLECTIONS.DELETE;
        CHAR_COLLECTIONS.DELETE;

    END;

BEGIN

    RQ_DATA_BY_NUM  := REQUEST_DATA_BY_NUM_SYMBOL;
    RQ_DATA_BY_NAME := REQUEST_DATA_BY_NAME_SYMBOL;

END VKREP;
/
